"""File:  CanvasTest_tags_thread.py  Test animation with time.sleep
   in separate threads"""
from Tkinter import *
import CanvasTest_tags
import time
import sys
import thread

class CanvasEvents(CanvasTest_tags.Application):

    def _init(self):
        CanvasTest_tags.__init__(self)

    def _moveShape(self, tag, cursor_x, cursor_y):
        thread.start_new_thread(self._moveThem, (tag, cursor_x, cursor_y))

    def _moveThem(self, tag, cursor_x, cursor_y):
        cursor_x = float(cursor_x)
        cursor_y = float(cursor_y)
        print 'IN _moveShape: tag =',tag,'x=',cursor_x, 'y=', cursor_y
        print 'CanvasTest_tags.Application.SPEED',CanvasTest_tags.Application.SPEED
        idList = self._myCanvas.find_withtag(tag)
        for i in xrange(5):
            for shapeId in idList:
                coords = self._myCanvas.coords(shapeId)
                x0,y0,x1,y1 = coords
                print 'coords=',coords
                xDiff = (cursor_x-((x1+x0)/2))
                yDiff = (cursor_y-((y1+y0)/2))
                print 'shapeId =',shapeId,'xDiff=',xDiff, 'yDiff=',yDiff
                if xDiff > CanvasTest_tags.Application.SPEED:
                    xDiff = CanvasTest_tags.Application.SPEED
                elif xDiff < -CanvasTest_tags.Application.SPEED:
                    xDiff = -CanvasTest_tags.Application.SPEED
                else:
                    xDiff = 0

                if yDiff > CanvasTest_tags.Application.SPEED:
                    yDiff = CanvasTest_tags.Application.SPEED
                elif yDiff < -CanvasTest_tags.Application.SPEED:
                    yDiff = -CanvasTest_tags.Application.SPEED
                else:
                    yDiff = 0
                print 'shapeId =',shapeId,'xDiff=',xDiff, 'yDiff=',yDiff
                self._myCanvas.move(shapeId, xDiff, yDiff)
                time.sleep(0.1)


def main():
    """Instantiate and pop up the window."""
    CanvasEvents().mainloop()

main()
